unit Main;
////////////////////////////////////////////////////////////////////////////////
//
//                 PR-x08.DLL
//
//             
//
////////////////////////////////////////////////////////////////////////////////

                            interface
////////////////////////////////////////////////////////////////////////////////
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, Menus, AppEvnts,
  PRTypes;

type
  TfrmMain = class(TForm)
    btnRefresh: TBitBtn;
    sbrStatus: TStatusBar;
    lbxReaders: TListBox;
    btnOpenReader: TBitBtn;
    btnCloseReader: TBitBtn;
    btnBeep: TBitBtn;
    btnBeepCfg: TBitBtn;
    cbxBeepOnCard: TCheckBox;
    cbxLedOnCard: TCheckBox;
    Bevel1: TBevel;
    grbReaderInfo: TGroupBox;
    btnGetInfo: TBitBtn;
    memInfo: TMemo;
    edtCardNumber: TEdit;
    Label1: TLabel;
    MainMenu1: TMainMenu;
    miFile: TMenuItem;
    miHelp: TMenuItem;
    miFileExit: TMenuItem;
    miHelpAbout: TMenuItem;
    btnActivateTypeA_4: TBitBtn;
    edtApduSend: TEdit;
    rgrActivationType: TRadioGroup;
    btnApduTest: TBitBtn;
    btnApduClear: TBitBtn;
    btnApduSend: TBitBtn;
    edtApduReceive: TEdit;
    procedure miHelpAboutClick(Sender: TObject);
    procedure miFileExitClick(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnOpenReaderClick(Sender: TObject);
    procedure btnCloseReaderClick(Sender: TObject);
    procedure btnBeepClick(Sender: TObject);
    procedure btnBeepCfgClick(Sender: TObject);
    procedure btnGetInfoClick(Sender: TObject);
    procedure btnActivateTypeA_4Click(Sender: TObject);
    procedure edtApduSendKeyPress(Sender: TObject; var Key: Char);
    procedure btnApduTestClick(Sender: TObject);
    procedure btnApduClearClick(Sender: TObject);
    procedure btnApduSendClick(Sender: TObject);
  private
    { Private declarations }
    ReaderOpened: boolean;
    //
    ChipType: TChipTypes;
    ReaderMode: TReaderModes;
    RFState: TRFStates;

    function ShowStatus(ACode: integer): integer;
    procedure EnableControls(enable: boolean);
    procedure MsgSelectReader;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

                           implementation
////////////////////////////////////////////////////////////////////////////////
{$R *.DFM}
uses
  //DLL_Main,
  PRx08,
  ErrCodes,
  ErrMsg,
  About;

var
  res: short;
  CurDesc: pansichar;

////////////////////////////////////////////////////////////////////////////////
function TfrmMain.ShowStatus(ACode: integer): integer;
begin
  sbrStatus.Panels[2].Text := ' = ' + IntToStr(ACode) + ' / ' +
    ErrMsgText(ACode);
  Result := ACode;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  //     ()
  GetMem(CurDesc, MAX_DESC_LEN);
  lbxReaders.Clear;
  btnRefreshClick(Self);
  ReaderOpened := false;
  EnableControls(false);
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  FreeMem(CurDesc);
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.EnableControls(enable: boolean);
var
  I: integer;
  Temp: TComponent;
  n: integer;
begin
  for I := 0 to ComponentCount - 1 do
  begin
    Temp := Components[I];
    // Button
    if (Temp is TButton) and (Temp.Tag = 2) then
        (Temp as TButton).Enabled := enable;
    if (Temp is TButton) and  (Temp.Tag = 3) then
      (Temp as TButton).Enabled := NOT enable;
    // TCheckBox
    if (Temp is TCheckBox) and (Temp.Tag = 2) then
      (Temp as TCheckBox).Enabled := enable;
    if (Temp is TCheckBox) and (Temp.Tag = 3) then
      (Temp as TCheckBox).Enabled := NOT enable;
    // ToolButton
    if (Temp is TToolButton) and (Temp.Tag = 2) then
        (Temp as TToolButton).Enabled := enable;
    if (Temp is TToolButton) and  (Temp.Tag = 3) then
      (Temp as TToolButton).Enabled := NOT enable;
    // TBitBtn
    if (Temp is TBitBtn) and (Temp.Tag = 2) then
        (Temp as TBitBtn).Enabled := enable;
    if (Temp is TBitBtn) and  (Temp.Tag = 3) then
      (Temp as TBitBtn).Enabled := NOT enable;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.miFileExitClick(Sender: TObject);
begin
  Application.Terminate;
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.miHelpAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

////////////////////////////////////////////////////////////////////////////////
//               
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.MsgSelectReader;
begin
  ShowMessage('      ');
end;

////////////////////////////////////////////////////////////////////////////////
//               
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnRefreshClick(Sender: TObject);
var
  n: integer;
begin
  //  
  lbxReaders.Clear;
  Application.ProcessMessages;
  n := Enumerate();
  sbrStatus.Panels[0].Text := 'Found ' + IntToStr(n);
  if ShowStatus(GetFirstReader(pbytearray(CurDesc), MAX_DESC_LEN)) = RES_OK then begin
    //  
    lbxReaders.Items.Add(CurDesc + ' - closed');
    //    
    while (GetNextReader(pbytearray(CurDesc), MAX_DESC_LEN) = RES_OK) do begin
      lbxReaders.Items.Add(CurDesc + ' - closed');
    end;
    lbxReaders.ItemIndex := 0;
  end;
  //   
  edtCardNumber.Text := '';
  ReaderOpened := false;
end;

procedure TfrmMain.edtApduSendKeyPress(Sender: TObject; var Key: Char);
var
  L: integer;
begin
  if Key < ' ' then
    exit;
  Key := UpCase(Key);
  if Key in ['0'..'9', 'A'..'F'] then
  begin
    L := length(edtApduSend.Text);
    if (((L + 1) mod 3) = 0) and (L > 1) then
    begin
      edtApduSend.Text := edtApduSend.Text + ' ';
      edtApduSend.SelStart := length(edtApduSend.Text);
    end;
  end else
    Key := #0;
end;

////////////////////////////////////////////////////////////////////////////////
//            ,    
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnOpenReaderClick(Sender: TObject);
var
  n: integer;
  s: string;
begin
  n := lbxReaders.ItemIndex;
  if n >=0 then begin
    res := ShowStatus(OpenReader(n));
    if res = RES_OK then begin
      s := lbxReaders.Items[n];
      System.Delete(s, length(s) - 8, 9);
      s := s + ' - OPENED';
      lbxReaders.Items[n] := s;
      //    :
      SetBeepBlinkMode(n, short(cbxLedOnCard.Checked), short(cbxBeepOnCard.Checked));
      //      
      btnGetInfo.Click();
      ReaderOpened := true;
      EnableControls(true);
    end;
  end else
    MsgSelectReader;
end;

////////////////////////////////////////////////////////////////////////////////
//            ,    
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnCloseReaderClick(Sender: TObject);
var
  n: integer;
  s: string;
begin
  n := lbxReaders.ItemIndex;
  if n >=0 then begin
    // 
    res := ShowStatus(CloseReader(n));
    s := lbxReaders.Items[n];
    System.Delete(s, length(s) - 8, 9);
    s := s + ' - closed';
    lbxReaders.Items[n] := s;
    ReaderOpened := false;
    EnableControls(false);
    btnApduSend.Enabled := false;
  end else
    MsgSelectReader;
  //   
  edtCardNumber.Text := '';
  memInfo.Lines.Clear;
end;

////////////////////////////////////////////////////////////////////////////////
//                       
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnBeepClick(Sender: TObject);
var
  n: integer;
begin
  n := lbxReaders.ItemIndex;
  if n >=0 then begin
    ShowStatus(BeepBlink(n));
  end else
    MsgSelectReader;
end;

////////////////////////////////////////////////////////////////////////////////
//                     
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnBeepCfgClick(Sender: TObject);
var
  n: integer;
  l, b: short;
begin
  n := lbxReaders.ItemIndex;
  if n >=0 then begin
    if (cbxBeepOnCard.Checked) then
      b := 1
    else
      b := 0;
    if (cbxLedOnCard.Checked) then
      l := 1
    else
      l := 0;
    ShowStatus(SetBeepBlinkMode(n, l, b));
  end else
    MsgSelectReader;
end;

////////////////////////////////////////////////////////////////////////////////
//                     
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnGetInfoClick(Sender: TObject);
var
  n: integer;
  inf: array[0..READER_INFO_SIZE] of byte;   //    16 !

  //     
  function ChipToStr(chip1, chip2: byte): string;
  var
    s: string;
  begin
    s := 'unknown';
    ChipType := ctUnknown;
    case chip1 of
      $33: begin
             s := 'MFRC400';
             ChipType := ct400;
           end;
      $88: case chip2 of
             $F8: begin
                    s := 'MFRC500';
                    ChipType := ct500;
                  end;
             $FE: begin
                    s := 'MFRC530';
                    ChipType := ct530;
                  end;
           end;
      $CC: begin
             s := 'MFRC531';
             ChipType := ct531;
           end;
      $FF: begin
             s := 'CLRC632';
             ChipType := ct632;
           end;
    end;
    result := s;
  end;

  //  
  function ModeToStr(m: byte): string;
  begin
    // TReaderModes = (rmTypeA, rmTypeB, rm15693, rmICode, rmMifare, rmEmMarin, rmHID, rmDallass, rmEM_HID, rmUnknown);
    ReaderMode := TReaderModes(m);
    case ReaderMode of
      rmTypeA     : result := 'ISO-14443A';
      rmTypeB     : result := 'ISO-14443B';
      rm15693     : result := 'ISO-15693';
      rmICode     : result := 'I-Code';
      rmMifare    : result := 'Mifare';
      rmEmMarin   : result := 'EM Marin';
      rmHID       : result := 'HID';
      rmDallass   : result := 'Dallass';
      rmEM_HID    : result := 'EM - HID';
    else
      result := 'Unknown';
    end;
  end;

  //   
  function RfToStr(rf: byte): string;
  begin
    case rf of
      0  : result := 'off';
      1  : result := 'Low';
      2  : result := 'HIGH';
    else
      result := '???';
    end;
  end;

  //  
  function InterfToStr(i: byte): string;
  {     USB !!! }
  begin
    if (i and $20) <> 0 then
      result := 'USB'
    else
      result := 'no USB';
  end;

begin // =======================================================================
  n := lbxReaders.ItemIndex;
  memInfo.Lines.Clear;
  if n >=0 then begin
    if ShowStatus(GetReaderInfo(n, @inf)) = RES_OK then begin
      //   ( ):
      memInfo.Lines.Add('ChipType:  ' + ChipToStr(inf[1], inf[2]));
      memInfo.Lines.Add('Mode:      ' + ModeToStr(inf[13]));
      memInfo.Lines.Add('Version:   ' + char(inf[9]) + '.' + char(inf[10]));
      memInfo.Lines.Add('RF State:  ' + RfToStr(inf[14]));
      memInfo.Lines.Add('Interface: ' + InterfToStr(inf[11]));
    end;
  end else
    MsgSelectReader;
end;

////////////////////////////////////////////////////////////////////////////////
//                   4
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnActivateTypeA_4Click(Sender: TObject);
var
  n: integer;
  uid: array[0..15] of byte;
  uidlen: short;
  s: string;
begin
  btnApduSend.Enabled := false;
  edtCardNumber.Text := '';
  sleep(500);
  n := lbxReaders.ItemIndex;
  if n >=0 then begin
    if ShowStatus(ActivateCardLevel4(n, rgrActivationType.ItemIndex, 240, @uid, uidlen)) = RES_OK then begin
      //  
      s := '';
      for n := 0 to (uidlen - 1) do begin
        s := s + IntToHex(uid[n], 2) + ' ';
      end;
      edtCardNumber.Text := s;
      btnApduSend.Enabled := true;
    end;
  end;

end;

////////////////////////////////////////////////////////////////////////////////
//                APDU   4
////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnApduClearClick(Sender: TObject);
begin
  edtApduSend.Text := '';
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnApduTestClick(Sender: TObject);
begin
  edtApduSend.Text := '02 00 A4 04 00 08 A0 00 00 04 87 03 07 07 00';
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmMain.btnApduSendClick(Sender: TObject);
var
  ApduSend, ApduReceive: TByteArray;
  slen, rlen: short;
  n: integer;

  //============================================================
  function HexTextToData(src: string; dest: PByteArray): short;
  var
    p: short;
    s: string;
    b: integer;
  begin
    //  :
    repeat
      p := Pos(' ', src);
      if p <> 0 then
        Delete(src, p, 1);
    until p = 0;
    //    
    p := 0;
    while (length(src) > 0) do begin
      s := System.Copy(src, 1, 2);
      if TryStrToInt('$0' + s, b) then
        dest[p] := byte(b);
      System.Delete(src, 1, 2);
      Inc(p);
    end;
    result := p;
  end;

begin
  edtApduReceive.Text := '';
  sleep(500);
  n := lbxReaders.ItemIndex;
  if n >= 0 then begin
    if (length(edtApduSend.Text) > 3) then begin
      FillChar(ApduSend, sizeof(ApduSend), 0);
      slen := HexTextToData(edtApduSend.Text, @ApduSend);
      if (slen > 1) then begin
        if ShowStatus(ExchangeApdu(n, @ApduSend, slen, @ApduReceive, rlen)) = RES_OK then begin
          //    
          for n := 0 to (rlen - 1) do
            edtApduReceive.Text := edtApduReceive.Text + IntToHex(ApduReceive[n], 2) + ' ';
        end;
      end;
    end;
  end;
end;

end.

